'project :	nixie
'created :	Sunday, January 20, 2002

$BAUD = 19200  'set 19200 baud rate for
$CRYSTAL = 22110800 '22.1108 MHz crystal
CONFIG SCL = P1.6									'P1.6 is the SCL line
CONFIG SDA = P1.7									'P1.7 is the SDA line


' CONSTANTS
DIM slaveAddressW AS CONST 208, slaveAddressR AS CONST 209 
DIM SecondAddress AS CONST 0, MinuteAddress AS CONST 1, HourAddress AS CONST 2
DIM DayAddress AS CONST 3, DateAddress AS CONST 4, MonthAddress AS CONST 5   
DIM YearAddress AS CONST 6, ControlAddress AS CONST 7 

' VARIABLES     
Dim addr as byte, value as byte				  		'dim used variables
Dim digit1 as byte , digit2 as byte, oldSecond as byte
Dim Second as byte, Minute as byte, Hour as byte, Day as byte
Dim Date as byte, Month as byte , Year as byte, Control as byte 

' FUNCTIONS
Declare Sub ReadDS1307(addr as byte)				'declare ReadDS1307
Declare Sub WriteDS1307(addr as byte, value as byte)'declare WriteDS1307
Declare Sub SetTime 								'declare SetTime

declare sub DisplayHours hours as byte
declare sub DisplaySecs secs as byte
declare sub DisplayMins mins as byte

dim i as byte

dim hoursOnes as byte
dim hoursTens as byte
dim minsOnes as byte
dim minsTens as byte
dim secsOnes as byte
dim secsTens as byte

dim hours as byte
dim mins as byte
dim secs as byte

dim port0 as byte
dim port1 as byte
dim port2 as byte
dim port3 as byte

dim toggleDisplay as byte
dim displayMode as byte
dim timeMode as const 0
dim dateMode as const 1

'Initialize RTC to 23:59:55 06/28/2001
oldSecond	= 255
Control		= 0
Second		= MAKEBCD(00)							'00..59
Minute		= MAKEBCD(01)							'00..59
Hour		= MAKEBCD(15)							'00..23
Date		= MAKEBCD(19)							'01..31
Day			= MAKEBCD(19)							'01..07
Month		= MAKEBCD(10)							'01..12
Year		= MAKEBCD(05)							'00..99
'Call SetTime

toggleDisplay = 0
displayMode = timeMode

Do
	Call ReadDS1307(SecondAddress)					'read the seconds only
	Second = value 	
	If oldSecond <> Second Then						'if new second Then update display
'Hour
		Call ReadDS1307(HourAddress)	
		Hour = value And &H7F
		Print BCD(Hour);
'Minute
		Call ReadDS1307(MinuteAddress)	
		Minute = value 
		Print ":";BCD(Minute);											
'Second
		Call ReadDS1307(SecondAddress)	
		Second = value And &H7F
		Print ":";BCD(Second);											
'Month
		Call ReadDS1307(MonthAddress)	
		Month = value And &H3F
		Print " ";BCD(Month);
'Date
		Call ReadDS1307(DateAddress)	
		Date = value And &H3F 
		Print "/";BCD(Date);											
'Year
		Call ReadDS1307(YearAddress)	
		Year = value 
		Print "/20";BCD(Year)					
'
		oldSecond = Second

		toggleDisplay = toggleDisplay + 1
		
		if toggleDisplay = 1 then
			toggleDisplay = 0
			if displayMode = timeMode then
				displayMode = dateMode
			else
				displayMode = timeMode
			end if
		end if

		if displayMode = timeMode then
			DisplayHours Hour
			DisplayMins Minute
			DisplaySecs Second
		else		
			DisplayHours Month
			DisplayMins Date
			DisplaySecs Year
		end if
				
	End if
	WAITMS 200										'waite 200 ms
Loop 
End


sub DisplayHours( hours as byte )
	
	P0 = hours
	
end sub

sub DisplayMins( mins as byte )
	
	P2 = mins
	
end sub

sub DisplaySecs( secs as byte )
	
	port1 = secs / 16
	port1 = port1 or &HF0
	P1 = port1
	
	port3 = secs and &h0f
	port3 = port3 * 16
	port3 = port3 or &h0f
	P3 = port3
	
end sub

'This subroutine reads a location (00..3F) of RTC RAM 
Sub ReadDS1307(addr as byte)						
	I2CSTART										
	I2CWBYTE  slaveAddressW							'send slave address (W bit = 0)
	I2CWBYTE  addr									'send address of RAM location
	I2CSTART										'generate start
	I2CWBYTE  slaveAddressR							'send slave address (R bit = 1)
	I2CRBYTE  value,NACK							'receive 1 byte from RTC 	
	I2CSTOP											'generate stop
End Sub
'This subroutine writes value into a location (00..3F) of RTC RAM  
Sub WriteDS1307(addr as byte,value as byte)						
	I2CSTART										'generate start
	I2CWBYTE  slaveAddressW							'send slave address (W bit = 0)
	I2CWBYTE  addr									'send address of RAM location
	I2CWBYTE  value									'send value
	I2CSTOP											'generate stop
End Sub
'This subroutine writes the  special registers of RTC
Sub SetTime
	Call WriteDS1307(SecondAddress,Second)
	Call WriteDS1307(MinuteAddress,Minute)
	Call WriteDS1307(HourAddress,Hour)
	Call WriteDS1307(DayAddress,Day)
	Call WriteDS1307(DateAddress,Date)
	Call WriteDS1307(MonthAddress,Month)
	Call WriteDS1307(YearAddress,Year)	
	Call WriteDS1307(ControlAddress,Control)	
End Sub
' End of File